#include "colors.inc"

/* Chris Becker aka Topher (c) 2002 */

camera {
 location <40,10,0> 
 look_at <0,10,0>


}  


light_source {<10,0,0> White*2 
area_light<0,0,10>,<10,0,0>,5,5 
adaptive 1
    jitter 
 }        

light_source {
  <100, -150, 0> color rgb<1, 1, 1> 
  cylinder
  point_at <-5, 0, 0>
  radius 50
  falloff 40
  tightness 1
  shadowless
}

#declare Pillar = union {
#declare S1=seed(132);
#declare i=0;
#while (i<10)
 #declare j=0;
 #while (j<30)   
  #declare value=rand(S1)*.25-.125+.5;
  superellipsoid{<.3,.3> rotate<0,i/10*360+90*mod(j,2),0> translate<sin(i/10*2*pi+pi/2*mod(j,2))*(3+rand(S1)/3),j*1.9,cos(i/10*2*pi+pi/2*mod(j,2))*(3+rand(S1)/3)> pigment{rgb<rand(S1)*.25-.125+.5,rand(S1)*.25-.125+.5,rand(S1)*.25-.125+.5>} }
  #declare j=j+1;
 #end
 #declare i=i+1;
#end 
}

object {Pillar translate <0,-7,-20> }
object {Pillar rotate <0,213,0> translate <0,-7,20> } 

// painting  
box {<-1,-1,-1,>,<1,1,1>   /*<.2,22.,15>,<-1,2.,-15>*/ pigment {image_map {jpeg  "Painting3.jpg"} warp{turbulence .10 lambda 30 } rotate<0,90,0> translate<0,.47,.53> scale<1,2,2>*1.3 } translate<3,1,0> scale<.2,10,15> #ifdef(FullQuality) normal {granite .50 scale .1} finish {phong 0.5} #end}      

union {
#declare S1=seed(132);
#declare i=0;
#while (i<40)
 #declare j=0;
 #while (j<500)   
  #declare value=rand(S1)*.25-.125+.5;  
  #if ((abs(cos(-i/40*pi)*j*1.5)>5)^(mod(floor(rand(S1)*10),10)=0))
  #if (rand(S1)>.9)
  box{<-1.3,-10.3,-1.3>,<1.3,2.3,1.3> rotate<0,-i/40*180> translate<sin(-i/40*pi)*j*1.5,rand(S1)*.01,cos(-i/40*pi)*j*1.5> pigment{rgb<rand(S1)*.25-.125+.5,rand(S1)*.25-.125+.5,rand(S1)*.25-.125+.5>} normal{agate .1 scale .1}}
  #end
  #else 
  
  box{<-1.3,-10.3,-1.3>,<1.3,2.3,1.3> rotate<0,-i/40*180> translate<sin(-i/40*pi)*j*1.5,rand(S1)*.01,cos(-i/40*pi)*j*1.5> pigment{rgb<(rand(S1)*.25-.125+.5)*3,1,0>} normal{agate .1 scale .1}}
  
  #end
  #declare j=j+1;
 #end
 #declare i=i+1;
#end 

translate <10,-7,0>
}
union {
#declare S1=seed(132);
#declare i=0;
#while (i<10)
 #declare j=1;
 #while (j<20)   
  #declare value=rand(S1)*.25-.125+.5;
  superellipsoid{<.3,.3> rotate<0,i/10*360+90*mod(j,2),0> translate<sin(i/10*2*pi+pi/2*mod(j,2))*(3+rand(S1)/3),j*1.9,cos(i/10*2*pi+pi/2*mod(j,2))*(3+rand(S1)/3)> pigment{rgb<rand(S1)*.25-.125+.5,rand(S1)*.25-.125+.5,rand(S1)*.25-.125+.5>} }
  #declare j=j+1;
 #end
 #declare i=i+1;
#end   
rotate <90,0,0>
translate <0,27,-19>
}

// stars
sky_sphere{
pigment {
        granite
        color_map {
            [ 0.000  0.270 color rgb < 0, 0, 0> color rgb < 0, 0, 0> ]
            [ 0.270  0.280 color rgb <.5,.5,.4> color rgb <.8,.8,.4> ]
            [ 0.280  0.470 color rgb < 0, 0, 0> color rgb < 0, 0, 0> ]
            [ 0.470  0.480 color rgb <.4,.4,.5> color rgb <.4,.4,.8> ]
            [ 0.480  0.680 color rgb < 0, 0, 0> color rgb < 0, 0, 0> ]
            [ 0.680  0.690 color rgb <.5,.4,.4> color rgb <.8,.4,.4> ]
            [ 0.690  0.880 color rgb < 0, 0, 0> color rgb < 0, 0, 0> ]
            [ 0.880  0.890 color rgb <.5,.5,.5> color rgb < 1, 1, 1> ]
            [ 0.890  1.000 color rgb < 0, 0, 0> color rgb < 0, 0, 0> ]
        }
    turbulence 1
    sine_wave
    scale .5
    }
    } 

plane{<0,1,0>,-5 pigment{Blue transmit .5} finish{reflection .9} normal{agate 1.0 scale 4} interior{ior 1.3}}
